import javax.swing.JFrame;
import javax.swing.JPanel;

public class Driver{
	
	public static void main(String args[]){
	
		/*initialize game variables*/
		TicTacToe board = new TicTacToe();
		HumanPlayer player1 = new HumanPlayer();
		DumbPlayer player2 = new DumbPlayer();
		GamePanel game = new GamePanel(board);
		
		/*set up the frame that has the game*/
		JFrame frame = new JFrame();
		frame.setSize(600, 400);
		frame.setContentPane(game);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setVisible(true);
		
		/*game play logic*/
		while (true){
			/*human plays*/
			if(!board.gameOver)
				playHuman(board, game, player1);
			
			if(board.gameOver){
				game.update();
				board.player = board.player;
				continue;
			}
			game.update();
			/*put in a delay*/
			try
			{Thread.sleep(800);}
			catch (Exception E){}
			
			/*computer plays*/
			if(!board.gameOver)
				playComp(board, game, player2);
			if(board.gameOver){
				game.update();
				continue;
			}
			game.update();
		}
	}
	/*this method plays the human and checks for the end of the game*/
	private static void playHuman(TicTacToe board, GamePanel game, HumanPlayer player1){
		if (!board.boardFull()) {
			player1.makeMove(board);
			game.update();
		}
		if (board.boardFull()&& board.isDraw()) { 
			game.messageLabel.setText("It is a draw");
			return;
		}
		if (board.isWin(-board.player)) { 
			if(board.player==TicTacToe.O)
				game.messageLabel.setText("X wins");
			else
				game.messageLabel.setText("O wins");
			board.gameOver = true;
			return;
		}
	}
	/*this method plays the computer and checks for the end of the game*/
	private static void playComp(TicTacToe board, GamePanel game, DumbPlayer player2){
		if (!board.boardFull()){
			player2.makeMove(board);
			game.update();
		}
		if (board.isWin(-board.player)) { 
			if(board.player==TicTacToe.O)
				game.messageLabel.setText("X wins");
			else
				game.messageLabel.setText("O wins");
			board.gameOver = true;
			return;
		}
		if (board.boardFull()&& board.isDraw()) { 
			game.messageLabel.setText("It is a draw");
			return;
		}
	
	}
}
